
FILE *comment_out;

void write_comment(uint8_t *buffer, size_t len)
{
  if (comment_out) {
    fwrite(buffer, 1, len, comment_out);
    fprintf(comment_out,"\n");
  }
}

void remove_comments(ifile_t *file,uint8_t **Rbuffer,size_t *Rlen)
{
  size_t i,j;
  obuffer_t *L;
  int dummy;
  size_t len;
  uint8_t *buffer;

  len= *Rlen;
  buffer= *Rbuffer;

  i= 0;
again:
  for(;i<len;i++)
   if (buffer[i]=='\'' || buffer[i]=='"') i= skip_quote(buffer,len,i);
   else if (buffer[i]=='/' && buffer[i+1]=='*') goto block_comment;
   else if (buffer[i]=='/' && buffer[i+1]=='/') goto line_comment;

done:
  *Rbuffer= buffer;
  *Rlen= len;
  return ;

line_comment:
  write_comment(buffer+i, len-i);
  len= i;
  buffer[len]= 0;
  goto done;

block_comment:
  for(j=i+2;j<len;j++)
    if (buffer[j]=='*' && buffer[j+1]=='/') break;
  if (j!=len)
  {
    write_comment(buffer+i, j+2-i);
    buffer[i]= ' ';
    remove_string(buffer, i+1, j+1,&len);
    goto again;
  }

  write_comment(buffer+i, len-i);
  buffer[i]= ' '; buffer[i+1]= 0; len= i+1;

  L= obuffer_new();
  linebuffer_add(L, buffer, len);

  while(!get_combined_line(file, &buffer, &len, &dummy))
  {
    for(j=0;j<len;j++)
      if (buffer[j]=='*' && buffer[j+1]=='/') break;
    if (j==len) { write_comment(buffer, len); free(buffer); continue; }
    write_comment(buffer, j+2);
    remove_string(buffer, 0, j+1,&len);
    linebuffer_add(L, buffer,len);
    break;
  }
  linebuffer_collect(L, &buffer, &len);
  goto again;
}


