/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <cinarus@yahoo.com> wrote this file. As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.
 * 
 * I don't guarantee that this program will work at all or that it won't
 *  delete all data on your disk. Use it at your own risk.
 * ----------------------------------------------------------------------------
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <stdint.h>

#include "simple.c"
#include "ifile.c"
#include "obuffer.c"
#include "linebuffer.c"
#include "util.c"
#include "combine.c"
#include "comment.c"

#include "cmdline.c"
#include "critbit.c"
#include "fnmanip.c"
#include "input.c"
FILE *output;

strmap_t *included_headers,*included_files;

#include "include.c"



int main(int argc,char **argv)
{
   int i;

   if (argc!=2) 
   {
 fprintf(stderr,
"C amalgamation tool.\n\n"
"THE BEER-WARE LICENSE (Revision 42):\n"
"<cinarus@yahoo.com> wrote this file. As long as you retain this notice you\n"
"can do whatever you want with this stuff. If we meet some day, and you think\n"
"this stuff is worth it, you can buy me a beer in return.\n"
"\n"
"I don't guarantee that this program will work at all or that it won't\n"
"delete all data on your disk. Use it at your own risk.\n"
"\nusage: %s input-file-name\n"
"\nThe input file consists of line-based commands.\n"
"   file file-name\n"
"       Adds the given file to the amalgamation.\n"
"   noprot file-name\n"
"       Normally, this program makes sure that each (#include)d file is \n"
"       inserted into the amalgamation only once. This command lifts such\n"
"       protection for the given file. If you want to do the same thing \n"
"       for system includes, simply enclose the file name in a <> pair.\n"
"   define var file-name\n"
"       This is used for stuff like #include SOME_HEADER. Here, 'var'\n"
"       can be a macro name or any other expression. If you use an \n"
"       expression which contains spaces, you can quote the expression\n"
"       using double quotes. In any case, var should look like exactly\n"
"       the way it does where it is (#include)d from (excepting the quotes,\n"
"       obviously).\n"
"   output file-name\n"
"       Defines the name of the output file. The default is amalgam-output.c\n"
"   search dir-name\n"
"       Adds dir-name to the list of directories to be searched when looking\n"
"       for a file because of an #include \"foo.h\" directive. For such\n"
"       directives, the file is searched for in the directory of the\n"
"       including file, after that it's searched for in the directories\n"
"       given by search commands. The order in which these commands are given\n"
"       is significant, the same order is used during the search.\n"
"   # comment\n"
"       Anything following a # character on a line is ignored.\n"
"\nIn all cases, file names can be enclosed in double quotes. However, no\n"
"escape encoding can be used in them. ie. they are only useful for embedding\n"
"spaces in the file names, which is a pretty bad idea if you ask me.\n"
"\nFile names are relative to the path of the file in which they are \n"
"specified. For example a source file path is taken relative to the path\n"
"of the input file. Similarly, a header file path is relative to the path\n"
"of the source file including it.\n"
"\n",
argv[0]);
       exit(1);
   }

   included_headers= strmap_new();
   included_files= strmap_new();
   read_input_file(argv[1]);
   if (!output_file_name) output_file_name= "amalgam-output.c";
   output= fopen(output_file_name,"w");
   comment_out= output;

   fprintf(output,
               "/* This file is an amalgamation of several source files.\n"
               "   Please look for BEGIN FILE,END FILE and CONTINUE FILE\n"
               "   strings to browse contents of individual files contained\n"
               "   here. */\n");
   for(i=0;files[i];i++)
   {
     ifile_t *f;
     if (ifile_open(&f,files[i]))
      exit(fprintf(stderr,"input file %s: %s\n", argv[1], ifile_error(f)));
     process_file(f,files[i]);
   }

   fclose(output);
   return 0;
}


