
void replace_control_chars(uint8_t *data, size_t *Rlen)
{
   size_t i,len;
   len= *Rlen;
   for(i=0;i<len;i++)
   {
      switch(data[i])
      {
      case 0x7f:
      case 0x00: case 0x01: case 0x02: case 0x03: 
      case 0x04: case 0x05: case 0x06: case 0x07:
      case 0x08: case 0x09:            case 0x0b:
      case 0x0c:            case 0x0e: case 0x0f:
      case 0x10: case 0x11: case 0x12: case 0x13: 
      case 0x14: case 0x15: case 0x16: case 0x17:
      case 0x18: case 0x19: case 0x1a: case 0x1b:
      case 0x1c: case 0x1d: case 0x1e: case 0x1f:
         data[i]= ' ';
         break;
      }
   }
   if (len && data[len-1]=='\n') { data[len-1]= 0; len--; }
   if (len && data[len-1]=='\r') { data[len-1]= 0; len--; }
   *Rlen= len;
}

int remove_line_continuations(uint8_t *data, size_t len)
{
   int R;
   size_t i,j;

   R= 0;

   for(i=0;i<len;i++)
   {
     if (data[i]!='\\') continue;
     for(j=i+1;j<len;j++) if (data[j]!=' ') break;
     if (j<len && data[j]!='\n') continue;
     if (j==len) j--;
     for(;i<j+1;i++) { data[i]= 0; R++; }
     i--;
   } 
   return R;
}

